--- old/./mr_sas.c	Tue Nov  6 14:29:38 2012
+++ new/./mr_sas.c	Tue Nov  6 14:29:38 2012
@@ -353,506 +483,496 @@
 	}
 
 	switch (cmd) {
-		case DDI_ATTACH:
+	case DDI_ATTACH:
+		/* allocate the soft state for the instance */
+		if (ddi_soft_state_zalloc(mrsas_state, instance_no)
+		    != DDI_SUCCESS) {
+			cmn_err(CE_WARN,
+			    "mr_sas%d: Failed to allocate soft state",
+			    instance_no);
+			return (DDI_FAILURE);
+		}
 
-			/* allocate the soft state for the instance */
-			if (ddi_soft_state_zalloc(mrsas_state, instance_no)
-			    != DDI_SUCCESS) {
-				cmn_err(CE_WARN,
-				    "mr_sas%d: Failed to allocate soft state",
-				    instance_no);
+		instance = (struct mrsas_instance *)ddi_get_soft_state
+		    (mrsas_state, instance_no);
 
-				return (DDI_FAILURE);
-			}
+		if (instance == NULL) {
+			cmn_err(CE_WARN,
+			    "mr_sas%d: Bad soft state", instance_no);
+			ddi_soft_state_free(mrsas_state, instance_no);
+			return (DDI_FAILURE);
+		}
 
-			instance = (struct mrsas_instance *)ddi_get_soft_state
-			    (mrsas_state, instance_no);
+		instance->unroll.softs	= 1;
 
-			if (instance == NULL) {
-				cmn_err(CE_WARN,
-				    "mr_sas%d: Bad soft state", instance_no);
+		/* Setup the PCI configuration space handles */
+		if (pci_config_setup(dip, &instance->pci_handle) !=
+		    DDI_SUCCESS) {
+			cmn_err(CE_WARN,
+			    "mr_sas%d: pci config setup failed ",
+			    instance_no);
 
-				ddi_soft_state_free(mrsas_state, instance_no);
+			ddi_soft_state_free(mrsas_state, instance_no);
+			return (DDI_FAILURE);
+		}
 
-				return (DDI_FAILURE);
-			}
+		if (ddi_dev_nregs(dip, &nregs) != DDI_SUCCESS) {
+			cmn_err(CE_WARN,
+			    "mr_sas: failed to get registers.");
 
-			bzero((caddr_t)instance,
-			    sizeof (struct mrsas_instance));
+			pci_config_teardown(&instance->pci_handle);
+			ddi_soft_state_free(mrsas_state, instance_no);
+			return (DDI_FAILURE);
+		}
 
-			instance->unroll.softs  = 1;
+		vendor_id = pci_config_get16(instance->pci_handle,
+		    PCI_CONF_VENID);
+		device_id = pci_config_get16(instance->pci_handle,
+		    PCI_CONF_DEVID);
 
-			/* Setup the PCI configuration space handles */
-			if (pci_config_setup(dip, &instance->pci_handle) !=
-			    DDI_SUCCESS) {
-				cmn_err(CE_WARN,
-				    "mr_sas%d: pci config setup failed ",
-				    instance_no);
+		subsysvid = pci_config_get16(instance->pci_handle,
+		    PCI_CONF_SUBVENID);
+		subsysid = pci_config_get16(instance->pci_handle,
+		    PCI_CONF_SUBSYSID);
 
-				ddi_soft_state_free(mrsas_state, instance_no);
-				return (DDI_FAILURE);
-			}
-			if (instance->pci_handle == NULL) {
-				cmn_err(CE_WARN,
-				    "mr_sas%d: pci config setup failed ",
-				    instance_no);
-				ddi_soft_state_free(mrsas_state, instance_no);
-				return (DDI_FAILURE);
-			}
+		pci_config_put16(instance->pci_handle, PCI_CONF_COMM,
+		    (pci_config_get16(instance->pci_handle,
+		    PCI_CONF_COMM) | PCI_COMM_ME));
+		irq = pci_config_get8(instance->pci_handle,
+		    PCI_CONF_ILINE);
 
+		con_log(CL_DLEVEL1, (CE_CONT, "mr_sas%d: "
+		    "0x%x:0x%x 0x%x:0x%x, irq:%d drv-ver:%s",
+		    instance_no, vendor_id, device_id, subsysvid,
+		    subsysid, irq, MRSAS_VERSION));
 
+		/* enable bus-mastering */
+		command = pci_config_get16(instance->pci_handle,
+		    PCI_CONF_COMM);
 
-			if (ddi_dev_nregs(dip, &nregs) != DDI_SUCCESS) {
-				cmn_err(CE_WARN,
-				    "mr_sas: failed to get registers.");
+		if (!(command & PCI_COMM_ME)) {
+			command |= PCI_COMM_ME;
 
-				pci_config_teardown(&instance->pci_handle);
-				ddi_soft_state_free(mrsas_state, instance_no);
-				return (DDI_FAILURE);
-			}
+			pci_config_put16(instance->pci_handle,
+			    PCI_CONF_COMM, command);
 
-			vendor_id = pci_config_get16(instance->pci_handle,
-			    PCI_CONF_VENID);
-			device_id = pci_config_get16(instance->pci_handle,
-			    PCI_CONF_DEVID);
+			con_log(CL_ANN, (CE_CONT, "mr_sas%d: "
+			    "enable bus-mastering", instance_no));
+		} else {
+			con_log(CL_DLEVEL1, (CE_CONT, "mr_sas%d: "
+			    "bus-mastering already set", instance_no));
+		}
 
-			subsysvid = pci_config_get16(instance->pci_handle,
-			    PCI_CONF_SUBVENID);
-			subsysid = pci_config_get16(instance->pci_handle,
-			    PCI_CONF_SUBSYSID);
+		/* initialize function pointers */
+		switch (device_id) {
+		case PCI_DEVICE_ID_LSI_TBOLT:
+		case PCI_DEVICE_ID_LSI_INVADER:
+			con_log(CL_ANN, (CE_NOTE,
+			    "mr_sas: 2208 T.B. device detected"));
 
-			pci_config_put16(instance->pci_handle, PCI_CONF_COMM,
-			    (pci_config_get16(instance->pci_handle,
-			    PCI_CONF_COMM) | PCI_COMM_ME));
-			irq = pci_config_get8(instance->pci_handle,
-			    PCI_CONF_ILINE);
+			instance->func_ptr =
+			    &mrsas_function_template_fusion;
+			instance->tbolt = 1;
+			break;
 
-			con_log(CL_DLEVEL1, (CE_CONT, "mr_sas%d: "
-			    "0x%x:0x%x 0x%x:0x%x, irq:%d drv-ver:%s",
-			    instance_no, vendor_id, device_id, subsysvid,
-			    subsysid, irq, MRSAS_VERSION));
+		case PCI_DEVICE_ID_LSI_2108VDE:
+		case PCI_DEVICE_ID_LSI_2108V:
+			con_log(CL_ANN, (CE_NOTE,
+			    "mr_sas: 2108 Liberator device detected"));
 
-			/* enable bus-mastering */
-			command = pci_config_get16(instance->pci_handle,
-			    PCI_CONF_COMM);
+			instance->func_ptr =
+			    &mrsas_function_template_ppc;
+			break;
 
-			if (!(command & PCI_COMM_ME)) {
-				command |= PCI_COMM_ME;
+		default:
+			cmn_err(CE_WARN,
+			    "mr_sas: Invalid device detected");
 
-				pci_config_put16(instance->pci_handle,
-				    PCI_CONF_COMM, command);
+			pci_config_teardown(&instance->pci_handle);
+			ddi_soft_state_free(mrsas_state, instance_no);
+			return (DDI_FAILURE);
+		}
 
-				con_log(CL_ANN, (CE_CONT, "mr_sas%d: "
-				    "enable bus-mastering", instance_no));
-			} else {
-				con_log(CL_DLEVEL1, (CE_CONT, "mr_sas%d: "
-				"bus-mastering already set", instance_no));
-			}
+		instance->baseaddress = pci_config_get32(
+		    instance->pci_handle, PCI_CONF_BASE0);
+		instance->baseaddress &= 0x0fffc;
 
-			/* initialize function pointers */
-		       switch(device_id) {
-				case PCI_DEVICE_ID_LSI_TBOLT:
-				case PCI_DEVICE_ID_LSI_INVADER:
-					con_log(CL_ANN, (CE_NOTE,
-					    "mr_sas: 2208 T.B. device detected"));
+		instance->dip		= dip;
+		instance->vendor_id	= vendor_id;
+		instance->device_id	= device_id;
+		instance->subsysvid	= subsysvid;
+		instance->subsysid	= subsysid;
+		instance->instance	= instance_no;
 
-					instance->func_ptr = &mrsas_function_template_fusion;
-					instance->tbolt = 1;
-					break;
+		/* Initialize FMA */
+		instance->fm_capabilities = ddi_prop_get_int(
+		    DDI_DEV_T_ANY, instance->dip, DDI_PROP_DONTPASS,
+		    "fm-capable", DDI_FM_EREPORT_CAPABLE |
+		    DDI_FM_ACCCHK_CAPABLE | DDI_FM_DMACHK_CAPABLE
+		    | DDI_FM_ERRCB_CAPABLE);
 
-				case PCI_DEVICE_ID_LSI_2108VDE:
-				case PCI_DEVICE_ID_LSI_2108V:
-					con_log(CL_ANN, (CE_NOTE,
-					    "mr_sas: 2108 Liberator device detected"));
+		mrsas_fm_init(instance);
 
-					instance->func_ptr = &mrsas_function_template_ppc;
-					break;
+		/* Setup register map */
+		if ((ddi_dev_regsize(instance->dip,
+		    REGISTER_SET_IO_2108, &reglength) != DDI_SUCCESS) ||
+		    reglength < MINIMUM_MFI_MEM_SZ) {
+			goto fail_attach;
+		}
+		if (reglength > DEFAULT_MFI_MEM_SZ) {
+			reglength = DEFAULT_MFI_MEM_SZ;
+			con_log(CL_DLEVEL1, (CE_NOTE,
+			    "mr_sas: register length to map is 0x%lx bytes",
+			    reglength));
+		}
+		if (ddi_regs_map_setup(instance->dip,
+		    REGISTER_SET_IO_2108, &instance->regmap, 0,
+		    reglength, &endian_attr, &instance->regmap_handle)
+		    != DDI_SUCCESS) {
+			cmn_err(CE_WARN,
+			    "mr_sas: couldn't map control registers");
+			goto fail_attach;
+		}
 
-				default:
-					cmn_err(CE_WARN,
-					    "mr_sas: Invalid device detected");
+		instance->unroll.regs = 1;
 
-					pci_config_teardown(&instance->pci_handle);
-					ddi_soft_state_free(mrsas_state, instance_no);
-					return (DDI_FAILURE);
+		/*
+		 * Disable Interrupt Now.
+		 * Setup Software interrupt
+		 */
+		instance->func_ptr->disable_intr(instance);
 
-		        }
+		if (ddi_prop_lookup_string(DDI_DEV_T_ANY, dip, 0,
+		    "mrsas-enable-msi", &data) == DDI_SUCCESS) {
+			if (strncmp(data, "no", 3) == 0) {
+				msi_enable = 0;
+				con_log(CL_ANN1, (CE_WARN,
+				    "msi_enable = %d disabled", msi_enable));
+			}
+			ddi_prop_free(data);
+		}
 
-			instance->baseaddress = pci_config_get32(
-			    instance->pci_handle, PCI_CONF_BASE0);
-			instance->baseaddress &= 0x0fffc;
+		con_log(CL_DLEVEL1, (CE_NOTE, "msi_enable = %d", msi_enable));
 
-			instance->dip		= dip;
-			instance->vendor_id	= vendor_id;
-			instance->device_id	= device_id;
-			instance->subsysvid	= subsysvid;
-			instance->subsysid	= subsysid;
-			instance->instance	= instance_no;
+		if (ddi_prop_lookup_string(DDI_DEV_T_ANY, dip, 0,
+		    "mrsas-enable-fp", &data) == DDI_SUCCESS) {
+			if (strncmp(data, "no", 3) == 0) {
+				enable_fp = 0;
+				cmn_err(CE_NOTE,
+				    "enable_fp = %d, Fast-Path disabled.\n",
+				    enable_fp);
+			}
 
+			ddi_prop_free(data);
+		}
 
-			/* Setup register map */
-			if ((ddi_dev_regsize(instance->dip,
-			    REGISTER_SET_IO_2108, &reglength) != DDI_SUCCESS) ||
-			    reglength < MINIMUM_MFI_MEM_SZ) {
+		con_log(CL_DLEVEL1, (CE_NOTE, "enable_fp = %d\n", enable_fp));
+
+		/* Check for all supported interrupt types */
+		if (ddi_intr_get_supported_types(
+		    dip, &intr_types) != DDI_SUCCESS) {
+			cmn_err(CE_WARN,
+			    "ddi_intr_get_supported_types() failed");
+			goto fail_attach;
+		}
+
+		con_log(CL_DLEVEL1, (CE_NOTE,
+		    "ddi_intr_get_supported_types() ret: 0x%x", intr_types));
+
+		/* Initialize and Setup Interrupt handler */
+		if (msi_enable && (intr_types & DDI_INTR_TYPE_MSIX)) {
+			if (mrsas_add_intrs(instance, DDI_INTR_TYPE_MSIX) !=
+			    DDI_SUCCESS) {
+				cmn_err(CE_WARN,
+				    "MSIX interrupt query failed");
 				goto fail_attach;
 			}
-			if (reglength > DEFAULT_MFI_MEM_SZ) {
-				reglength = DEFAULT_MFI_MEM_SZ;
-				con_log(CL_DLEVEL1, (CE_NOTE,
-				    "mr_sas: register length to map is "
-				    "0x%lx bytes", reglength));
-			}
-			if (ddi_regs_map_setup(instance->dip,
-			    REGISTER_SET_IO_2108, &instance->regmap, 0,
-			    reglength, &endian_attr, &instance->regmap_handle)
-			    != DDI_SUCCESS) {
+			instance->intr_type = DDI_INTR_TYPE_MSIX;
+		} else if (msi_enable && (intr_types & DDI_INTR_TYPE_MSI)) {
+			if (mrsas_add_intrs(instance, DDI_INTR_TYPE_MSI) !=
+			    DDI_SUCCESS) {
 				cmn_err(CE_WARN,
-				    "mr_sas: couldn't map control registers");
+				    "MSI interrupt query failed");
 				goto fail_attach;
 			}
-			if (instance->regmap_handle == NULL) {
+			instance->intr_type = DDI_INTR_TYPE_MSI;
+		} else if (intr_types & DDI_INTR_TYPE_FIXED) {
+			msi_enable = 0;
+			if (mrsas_add_intrs(instance, DDI_INTR_TYPE_FIXED) !=
+			    DDI_SUCCESS) {
 				cmn_err(CE_WARN,
-				    "mr_sas: couldn't map control registers");
+				    "FIXED interrupt query failed");
 				goto fail_attach;
 			}
+			instance->intr_type = DDI_INTR_TYPE_FIXED;
+		} else {
+			cmn_err(CE_WARN, "Device cannot "
+			    "suppport either FIXED or MSI/X "
+			    "interrupts");
+			goto fail_attach;
+		}
 
-			instance->unroll.regs = 1;
+		instance->unroll.intr = 1;
 
-			/*
-			 * Disable Interrupt Now.
-			 * Setup Software interrupt
-			 */
-			instance->func_ptr->disable_intr(instance);
-
-			if (ddi_prop_lookup_string(DDI_DEV_T_ANY, dip, 0,
-			    "mrsas-enable-msi", &data) == DDI_SUCCESS) {
-				if (strncmp(data, "no", 3) == 0) {
-					msi_enable = 0;
-					con_log(CL_ANN1, (CE_WARN,
-					    "msi_enable = %d disabled",
-					    msi_enable));
-				}
-				ddi_prop_free(data);
+		if (ddi_prop_lookup_string(DDI_DEV_T_ANY, dip, 0,
+		    "mrsas-enable-ctio", &data) == DDI_SUCCESS) {
+			if (strncmp(data, "no", 3) == 0) {
+				ctio_enable = 0;
+				con_log(CL_ANN1, (CE_WARN,
+				    "ctio_enable = %d disabled", ctio_enable));
 			}
+			ddi_prop_free(data);
+		}
 
-			con_log(CL_DLEVEL1, (CE_NOTE, "msi_enable = %d", msi_enable));
+		con_log(CL_DLEVEL1, (CE_WARN, "ctio_enable = %d", ctio_enable));
 
-			if (ddi_prop_lookup_string(DDI_DEV_T_ANY, dip, 0,
-			    "mrsas-enable-fp", &data) == DDI_SUCCESS) {
-				if (strncmp(data, "no", 3) == 0) {
-					enable_fp = 0;
-					cmn_err(CE_NOTE,
-					    "enable_fp = %d, Fast-Path disabled.\n",
-					    enable_fp);
-				}
+		/* setup the mfi based low level driver */
+		if (mrsas_init_adapter(instance) != DDI_SUCCESS) {
+			cmn_err(CE_WARN, "mr_sas: "
+			    "could not initialize the low level driver");
 
-				ddi_prop_free(data);
-			}
+			goto fail_attach;
+		}
 
-			cmn_err(CE_NOTE, "enable_fp = %d\n", enable_fp);
+		/* Initialize all Mutex */
+		INIT_LIST_HEAD(&instance->completed_pool_list);
+		mutex_init(&instance->completed_pool_mtx, NULL,
+		    MUTEX_DRIVER, DDI_INTR_PRI(instance->intr_pri));
 
-			/* Check for all supported interrupt types */
-			if (ddi_intr_get_supported_types(
-			    dip, &intr_types) != DDI_SUCCESS) {
-				cmn_err(CE_WARN,
-				    "ddi_intr_get_supported_types() failed");
-				goto fail_attach;
-			}
+		mutex_init(&instance->sync_map_mtx, NULL,
+		    MUTEX_DRIVER, DDI_INTR_PRI(instance->intr_pri));
 
-			con_log(CL_DLEVEL1, (CE_NOTE,
-			    "ddi_intr_get_supported_types() ret: 0x%x",
-			    intr_types));
+		mutex_init(&instance->app_cmd_pool_mtx, NULL,
+		    MUTEX_DRIVER, DDI_INTR_PRI(instance->intr_pri));
 
-			/* Initialize and Setup Interrupt handler */
-			if (msi_enable && (intr_types & DDI_INTR_TYPE_MSIX)) {
-				if (mrsas_add_intrs(instance,
-				    DDI_INTR_TYPE_MSIX) != DDI_SUCCESS) {
-					cmn_err(CE_WARN,
-					    "MSIX interrupt query failed");
-					goto fail_attach;
-				}
-				instance->intr_type = DDI_INTR_TYPE_MSIX;
-			} else if (msi_enable && (intr_types &
-			    DDI_INTR_TYPE_MSI)) {
-				if (mrsas_add_intrs(instance,
-				    DDI_INTR_TYPE_MSI) != DDI_SUCCESS) {
-					cmn_err(CE_WARN,
-					    "MSI interrupt query failed");
-					goto fail_attach;
-				}
-				instance->intr_type = DDI_INTR_TYPE_MSI;
-			} else if (intr_types & DDI_INTR_TYPE_FIXED) {
-				msi_enable = 0;
-				if (mrsas_add_intrs(instance,
-				    DDI_INTR_TYPE_FIXED) != DDI_SUCCESS) {
-					cmn_err(CE_WARN,
-					    "FIXED interrupt query failed");
-					goto fail_attach;
-				}
-				instance->intr_type = DDI_INTR_TYPE_FIXED;
-			} else {
-				cmn_err(CE_WARN, "Device cannot "
-				    "suppport either FIXED or MSI/X "
-				    "interrupts");
-				goto fail_attach;
-			}
+		mutex_init(&instance->config_dev_mtx, NULL,
+		    MUTEX_DRIVER, DDI_INTR_PRI(instance->intr_pri));
 
-			instance->unroll.intr = 1;
+		mutex_init(&instance->cmd_pend_mtx, NULL,
+		    MUTEX_DRIVER, DDI_INTR_PRI(instance->intr_pri));
 
+		mutex_init(&instance->ocr_flags_mtx, NULL,
+		    MUTEX_DRIVER, DDI_INTR_PRI(instance->intr_pri));
 
-			/* setup the mfi based low level driver */
-			if (mrsas_init_adapter(instance) != DDI_SUCCESS) {
-				cmn_err(CE_WARN, "mr_sas: "
-				"could not initialize the low level driver");
+		mutex_init(&instance->int_cmd_mtx, NULL,
+		    MUTEX_DRIVER, DDI_INTR_PRI(instance->intr_pri));
+		cv_init(&instance->int_cmd_cv, NULL, CV_DRIVER, NULL);
 
-				goto fail_attach;
-			}
+		mutex_init(&instance->cmd_pool_mtx, NULL,
+		    MUTEX_DRIVER, DDI_INTR_PRI(instance->intr_pri));
 
-			/* Initialize all Mutex */
-			INIT_LIST_HEAD(&instance->completed_pool_list);
-			mutex_init(&instance->completed_pool_mtx,
-			    "completed_pool_mtx", MUTEX_DRIVER,
-			    DDI_INTR_PRI(instance->intr_pri));
-			
-			mutex_init(&instance->sync_map_mtx,
-			    "sync_map_mtx", MUTEX_DRIVER,
-			    DDI_INTR_PRI(instance->intr_pri));
-			
-			mutex_init(&instance->app_cmd_pool_mtx,
-			    "app_cmd_pool_mtx",	MUTEX_DRIVER,
-			    DDI_INTR_PRI(instance->intr_pri));
+		mutex_init(&instance->reg_write_mtx, NULL,
+		    MUTEX_DRIVER, DDI_INTR_PRI(instance->intr_pri));
 
-			mutex_init(&instance->config_dev_mtx, "config_dev_mtx",
+		if (instance->tbolt) {
+			mutex_init(&instance->cmd_app_pool_mtx, NULL,
 			    MUTEX_DRIVER, DDI_INTR_PRI(instance->intr_pri));
 
-			mutex_init(&instance->cmd_pend_mtx, "cmd_pend_mtx",
+			mutex_init(&instance->chip_mtx, NULL,
 			    MUTEX_DRIVER, DDI_INTR_PRI(instance->intr_pri));
 
-			mutex_init(&instance->ocr_flags_mtx, "ocr_flags_mtx",
-			    MUTEX_DRIVER, DDI_INTR_PRI(instance->intr_pri));
+		}
 
-			mutex_init(&instance->int_cmd_mtx, "int_cmd_mtx",
-			    MUTEX_DRIVER, DDI_INTR_PRI(instance->intr_pri));
-			cv_init(&instance->int_cmd_cv, NULL, CV_DRIVER, NULL);
+		instance->unroll.mutexs = 1;
 
-			mutex_init(&instance->cmd_pool_mtx, "cmd_pool_mtx",
-			    MUTEX_DRIVER, DDI_INTR_PRI(instance->intr_pri));
+		instance->timeout_id = (timeout_id_t)-1;
 
-			mutex_init(&instance->reg_write_mtx,"reg_write_mtx", 
-				MUTEX_DRIVER,DDI_INTR_PRI(instance->intr_pri));
+		/* Register our soft-isr for highlevel interrupts. */
+		instance->isr_level = instance->intr_pri;
+		if (!(instance->tbolt)) {
+			if (instance->isr_level == HIGH_LEVEL_INTR) {
+				if (ddi_add_softintr(dip,
+				    DDI_SOFTINT_HIGH,
+				    &instance->soft_intr_id, NULL, NULL,
+				    mrsas_softintr, (caddr_t)instance) !=
+				    DDI_SUCCESS) {
+					cmn_err(CE_WARN,
+					    "Software ISR did not register");
 
-			if (instance->tbolt) {
-				mutex_init(&instance->cmd_app_pool_mtx,
-				    "cmd_app_pool_mtx", MUTEX_DRIVER,
-				    DDI_INTR_PRI(instance->intr_pri));
+					goto fail_attach;
+				}
 
-				mutex_init(&instance->chip_mtx,
-				    "chip_mtx", MUTEX_DRIVER,
-				    DDI_INTR_PRI(instance->intr_pri));
+				instance->unroll.soft_isr = 1;
 
 			}
+		}
 
-			instance->unroll.mutexs = 1;
+		instance->softint_running = 0;
 
-			instance->timeout_id = (timeout_id_t)-1;
+		/* Allocate a transport structure */
+		tran = scsi_hba_tran_alloc(dip, SCSI_HBA_CANSLEEP);
 
-			/* Register our soft-isr for highlevel interrupts. */
-			instance->isr_level = instance->intr_pri;
-			if (!(instance->tbolt)) {
-				if (instance->isr_level == HIGH_LEVEL_INTR) {
-					if (ddi_add_softintr(dip,
-					    DDI_SOFTINT_HIGH,
-					    &instance->soft_intr_id,
-					    NULL, NULL, mrsas_softintr,
-					    (caddr_t)instance) !=
-					    DDI_SUCCESS) {
-						cmn_err(CE_WARN,
-						    "Software ISR "
-						    "did not register");
+		if (tran == NULL) {
+			cmn_err(CE_WARN,
+			    "scsi_hba_tran_alloc failed");
+			goto fail_attach;
+		}
 
-						goto fail_attach;
-					}
+		instance->tran = tran;
+		instance->unroll.tran = 1;
 
-					instance->unroll.soft_isr = 1;
+		tran->tran_hba_private	= instance;
+		tran->tran_tgt_init	= mrsas_tran_tgt_init;
+		tran->tran_tgt_probe	= scsi_hba_probe;
+		tran->tran_tgt_free	= mrsas_tran_tgt_free;
+		if (instance->tbolt) {
+			tran->tran_init_pkt	=
+			    mrsas_tbolt_tran_init_pkt;
+			tran->tran_start	=
+			    mrsas_tbolt_tran_start;
+		} else {
+			tran->tran_init_pkt	= mrsas_tran_init_pkt;
+			tran->tran_start	= mrsas_tran_start;
+		}
+		tran->tran_abort	= mrsas_tran_abort;
+		tran->tran_reset	= mrsas_tran_reset;
+		tran->tran_getcap	= mrsas_tran_getcap;
+		tran->tran_setcap	= mrsas_tran_setcap;
+		tran->tran_destroy_pkt	= mrsas_tran_destroy_pkt;
+		tran->tran_dmafree	= mrsas_tran_dmafree;
+		tran->tran_sync_pkt	= mrsas_tran_sync_pkt;
+		tran->tran_quiesce	= mrsas_tran_quiesce;
+		tran->tran_unquiesce	= mrsas_tran_unquiesce;
+		tran->tran_bus_config	= mrsas_tran_bus_config;
 
-				}
-			}
+		if (mrsas_relaxed_ordering)
+			mrsas_generic_dma_attr.dma_attr_flags |=
+			    DDI_DMA_RELAXED_ORDERING;
 
-			instance->softint_running = 0;
 
-			/* Allocate a transport structure */
-			tran = scsi_hba_tran_alloc(dip, SCSI_HBA_CANSLEEP);
+		tran_dma_attr = mrsas_generic_dma_attr;
+		tran_dma_attr.dma_attr_sgllen = instance->max_num_sge;
 
-			if (tran == NULL) {
-				cmn_err(CE_WARN,
-				    "scsi_hba_tran_alloc failed");
-				goto fail_attach;
-			}
+		/* Attach this instance of the hba */
+		if (scsi_hba_attach_setup(dip, &tran_dma_attr, tran, 0)
+		    != DDI_SUCCESS) {
+			cmn_err(CE_WARN,
+			    "scsi_hba_attach failed");
 
-			instance->tran = tran;
-			instance->unroll.tran = 1;
+			goto fail_attach;
+		}
+		instance->unroll.tranSetup = 1;
+		con_log(CL_ANN1,
+		    (CE_CONT, "scsi_hba_attach_setup()	done."));
 
-			tran->tran_hba_private	= instance;
-			tran->tran_tgt_init	= mrsas_tran_tgt_init;
-			tran->tran_tgt_probe	= scsi_hba_probe;
-			tran->tran_tgt_free	= mrsas_tran_tgt_free;
-			if (instance->tbolt) {
-				tran->tran_init_pkt	=
-				    mrsas_tbolt_tran_init_pkt;
-				tran->tran_start	=
-				    mrsas_tbolt_tran_start;
-			} else {
-				tran->tran_init_pkt	= mrsas_tran_init_pkt;
-				tran->tran_start	= mrsas_tran_start;
-			}
-			tran->tran_abort	= mrsas_tran_abort;
-			tran->tran_reset	= mrsas_tran_reset;
-			tran->tran_getcap	= mrsas_tran_getcap;
-			tran->tran_setcap	= mrsas_tran_setcap;
-			tran->tran_destroy_pkt	= mrsas_tran_destroy_pkt;
-			tran->tran_dmafree	= mrsas_tran_dmafree;
-			tran->tran_sync_pkt	= mrsas_tran_sync_pkt;
-			tran->tran_quiesce	= mrsas_tran_quiesce;
-			tran->tran_unquiesce	= mrsas_tran_unquiesce;
-			tran->tran_bus_config	= mrsas_tran_bus_config;
+		/* create devctl node for cfgadm command */
+		if (ddi_create_minor_node(dip, "devctl",
+		    S_IFCHR, INST2DEVCTL(instance_no),
+		    DDI_NT_SCSI_NEXUS, 0) == DDI_FAILURE) {
+			cmn_err(CE_WARN,
+			    "mr_sas: failed to create devctl node.");
 
-			if (mrsas_relaxed_ordering)
-				mrsas_generic_dma_attr.dma_attr_flags |=
-				    DDI_DMA_RELAXED_ORDERING;
+			goto fail_attach;
+		}
 
+		instance->unroll.devctl = 1;
 
-			tran_dma_attr = mrsas_generic_dma_attr;
-			tran_dma_attr.dma_attr_sgllen = instance->max_num_sge;
+		/* create scsi node for cfgadm command */
+		if (ddi_create_minor_node(dip, "scsi", S_IFCHR,
+		    INST2SCSI(instance_no), DDI_NT_SCSI_ATTACHMENT_POINT, 0) ==
+		    DDI_FAILURE) {
+			cmn_err(CE_WARN,
+			    "mr_sas: failed to create scsi node.");
 
-			/* Attach this instance of the hba */
-			if (scsi_hba_attach_setup(dip, &tran_dma_attr, tran, 0)
-			    != DDI_SUCCESS) {
-				cmn_err(CE_WARN,
-				    "scsi_hba_attach failed");
+			goto fail_attach;
+		}
 
-				goto fail_attach;
-			}
-			instance->unroll.tranSetup = 1;
-			con_log(CL_ANN1, (CE_CONT,
-				"scsi_hba_attach_setup()  done."));
+		instance->unroll.scsictl = 1;
 
+		(void) sprintf(instance->iocnode, "%d:lsirdctl",
+		    instance_no);
 
-			/* create devctl node for cfgadm command */
-			if (ddi_create_minor_node(dip, "devctl",
-			    S_IFCHR, INST2DEVCTL(instance_no),
-			    DDI_NT_SCSI_NEXUS, 0) == DDI_FAILURE) {
-				cmn_err(CE_WARN,
-				    "mr_sas: failed to create devctl node.");
+		/*
+		 * Create a node for applications
+		 * for issuing ioctl to the driver.
+		 */
+		if (ddi_create_minor_node(dip, instance->iocnode,
+		    S_IFCHR, INST2LSIRDCTL(instance_no), DDI_PSEUDO, 0) ==
+		    DDI_FAILURE) {
+			cmn_err(CE_WARN,
+			    "mr_sas: failed to create ioctl node.");
 
-				goto fail_attach;
-			}
+			goto fail_attach;
+		}
 
-			instance->unroll.devctl = 1;
+		instance->unroll.ioctl = 1;
 
-			/* create scsi node for cfgadm command */
-			if (ddi_create_minor_node(dip, "scsi", S_IFCHR,
-			    INST2SCSI(instance_no),
-			    DDI_NT_SCSI_ATTACHMENT_POINT, 0) ==
-			    DDI_FAILURE) {
-				cmn_err(CE_WARN,
-				    "mr_sas: failed to create scsi node.");
+		/* Create a taskq to handle dr events */
+		if ((instance->taskq = ddi_taskq_create(dip,
+		    "mrsas_dr_taskq", 1, TASKQ_DEFAULTPRI, 0)) == NULL) {
+			cmn_err(CE_WARN,
+			    "mr_sas: failed to create taskq ");
+			instance->taskq = NULL;
+			goto fail_attach;
+		}
+		instance->unroll.taskq = 1;
+		con_log(CL_ANN1, (CE_CONT, "ddi_taskq_create()	done."));
 
-				goto fail_attach;
-			}
+		/* enable interrupt */
+		instance->func_ptr->enable_intr(instance);
 
-			instance->unroll.scsictl = 1;
+		/* initiate AEN */
+		if (start_mfi_aen(instance)) {
+			cmn_err(CE_WARN,
+			    "mr_sas: failed to initiate AEN.");
+			goto fail_attach;
+		}
+		instance->unroll.aenPend = 1;
+		con_log(CL_ANN1,
+		    (CE_CONT, "AEN started for instance %d.", instance_no));
 
-			(void) sprintf(instance->iocnode, "%d:lsirdctl",
-			    instance_no);
+		/* Finally! We are on the air.	*/
+		ddi_report_dev(dip);
 
-			/*
-			 * Create a node for applications
-			 * for issuing ioctl to the driver.
-			 */
-			if (ddi_create_minor_node(dip, instance->iocnode,
-			    S_IFCHR, INST2LSIRDCTL(instance_no),
-			    DDI_PSEUDO, 0) == DDI_FAILURE) {
-				cmn_err(CE_WARN,
-				    "mr_sas: failed to create ioctl node.");
+		/* FMA handle checking. */
+		if (mrsas_check_acc_handle(instance->regmap_handle) !=
+		    DDI_SUCCESS) {
+			goto fail_attach;
+		}
+		if (mrsas_check_acc_handle(instance->pci_handle) !=
+		    DDI_SUCCESS) {
+			goto fail_attach;
+		}
 
-				goto fail_attach;
-			}
+		instance->mr_ld_list =
+		    kmem_zalloc(MRDRV_MAX_LD * sizeof (struct mrsas_ld),
+		    KM_SLEEP);
+		instance->unroll.ldlist_buff = 1;
 
-			instance->unroll.ioctl = 1;
-
-			/* Create a taskq to handle dr events */
-			if ((instance->taskq = ddi_taskq_create(dip,
-			    "mrsas_dr_taskq", 1,
-			    TASKQ_DEFAULTPRI, 0)) == NULL) {
-				cmn_err(CE_WARN,
-				    "mr_sas: failed to create taskq ");
-				instance->taskq = NULL;
-				goto fail_attach;
+#ifdef PDSUPPORT
+		if (instance->tbolt) {
+			instance->mr_tbolt_pd_max = MRSAS_TBOLT_PD_TGT_MAX;
+			instance->mr_tbolt_pd_list =
+			    kmem_zalloc(MRSAS_TBOLT_GET_PD_MAX(instance) *
+			    sizeof (struct mrsas_tbolt_pd), KM_SLEEP);
+			ASSERT(instance->mr_tbolt_pd_list);
+			for (i = 0; i < instance->mr_tbolt_pd_max; i++) {
+				instance->mr_tbolt_pd_list[i].lun_type =
+				    MRSAS_TBOLT_PD_LUN;
+				instance->mr_tbolt_pd_list[i].dev_id =
+				    (uint8_t)i;
 			}
-			instance->unroll.taskq = 1;
-			con_log(CL_ANN1, (CE_CONT,
-				"ddi_taskq_create()  done."));
 
-			/* enable interrupt */
-			instance->func_ptr->enable_intr(instance);
-
-			/* initiate AEN */
-			if (start_mfi_aen(instance)) {
-					cmn_err(CE_WARN,
-				    "mr_sas: failed to initiate AEN.");
-				goto fail_attach;
-			}
-			instance->unroll.aenPend = 1;
-			con_log(CL_ANN1, (CE_CONT,
-			    "AEN started for instance %d.", instance_no));
-
-			/* Finally! We are on the air.  */
-			ddi_report_dev(dip);
-						
-			instance->mr_ld_list =
-			    kmem_zalloc(MRDRV_MAX_LD * sizeof (struct mrsas_ld),
-			    KM_SLEEP);
-			if (instance->mr_ld_list == NULL) {
-				cmn_err(CE_WARN,
-				    "mr_sas attach(): failed to allocate ld_list array");
-				goto fail_attach;
-			}
-			instance->unroll.ldlist_buff = 1;
-
-#ifdef PDSUPPORT
-			if(instance->tbolt) {
-				instance->mr_tbolt_pd_max = MRSAS_TBOLT_PD_TGT_MAX;
-				instance->mr_tbolt_pd_list =
-			    	    kmem_zalloc(MRSAS_TBOLT_GET_PD_MAX(instance)
-			    	    * sizeof (struct mrsas_tbolt_pd), KM_SLEEP);
-				ASSERT(instance->mr_tbolt_pd_list);
-				for (i = 0; i < instance->mr_tbolt_pd_max; i++) {
-					instance->mr_tbolt_pd_list[i].lun_type = 
-					    MRSAS_TBOLT_PD_LUN;
-					instance->mr_tbolt_pd_list[i].dev_id = 
-					    (uint8_t)i;
-				}
-
-				instance->unroll.pdlist_buff = 1;
-			}	
+			instance->unroll.pdlist_buff = 1;
+		}
 #endif
-			break;
-		case DDI_PM_RESUME:
-			con_log(CL_ANN, (CE_NOTE,
-			    "mr_sas: DDI_PM_RESUME"));
-			break;
-		case DDI_RESUME:
-			con_log(CL_ANN, (CE_NOTE,
-			    "mr_sas: DDI_RESUME"));
-			break;
-		default:
-			con_log(CL_ANN, (CE_WARN,
-			    "mr_sas: invalid attach cmd=%x", cmd));
-			return (DDI_FAILURE);
+		break;
+	case DDI_PM_RESUME:
+		con_log(CL_ANN, (CE_NOTE, "mr_sas: DDI_PM_RESUME"));
+		break;
+	case DDI_RESUME:
+		con_log(CL_ANN, (CE_NOTE, "mr_sas: DDI_RESUME"));
+		break;
+	default:
+		con_log(CL_ANN,
+		    (CE_WARN, "mr_sas: invalid attach cmd=%x", cmd));
+		return (DDI_FAILURE);
 	}
 
 
-	cmn_err(CE_NOTE, "mrsas_attach() return SUCCESS instance_num %d", instance_no);
+	con_log(CL_DLEVEL1,
+	    (CE_NOTE, "mrsas_attach() return SUCCESS instance_num %d",
+	    instance_no));
 	return (DDI_SUCCESS);
 
 fail_attach:
@@ -859,13 +979,18 @@
 
 	mrsas_undo_resources(dip, instance);
 
+	mrsas_fm_ereport(instance, DDI_FM_DEVICE_NO_RESPONSE);
+	ddi_fm_service_impact(instance->dip, DDI_SERVICE_LOST);
+
+	mrsas_fm_fini(instance);
+
 	pci_config_teardown(&instance->pci_handle);
 	ddi_soft_state_free(mrsas_state, instance_no);
 
-	con_log(CL_ANN, (CE_WARN,
-	    "mr_sas: return failure from mrsas_attach"));
+	con_log(CL_ANN, (CE_WARN, "mr_sas: return failure from mrsas_attach"));
 
-	cmn_err(CE_WARN, "mrsas_attach() return FAILURE instance_num %d", instance_no);
+	cmn_err(CE_WARN, "mrsas_attach() return FAILURE instance_num %d",
+	    instance_no);
 
 	return (DDI_FAILURE);
 }
@@ -981,14 +1106,16 @@
 			}
 			mutex_exit(&instance->config_dev_mtx);
 
-			if(instance->unroll.tranSetup == 1) {
+			if (instance->unroll.tranSetup == 1) {
 				if (scsi_hba_detach(dip) != DDI_SUCCESS) {
 					cmn_err(CE_WARN,
-						"mr_sas2%d: failed to detach", instance_no);
+					    "mr_sas2%d: failed to detach",
+					    instance_no);
 					return (DDI_FAILURE);
 				}
 				instance->unroll.tranSetup = 0;
-			        con_log(CL_ANN1, (CE_CONT, "scsi_hba_dettach()  done."));
+				con_log(CL_ANN1,
+				    (CE_CONT, "scsi_hba_dettach()  done."));
 			}
 
 			flush_cache(instance);
@@ -995,6 +1122,8 @@
 
 			mrsas_undo_resources(dip, instance);
 
+			mrsas_fm_fini(instance);
+
 			pci_config_teardown(&instance->pci_handle);
 			ddi_soft_state_free(mrsas_state, instance_no);
 			break;
@@ -1019,8 +1148,8 @@
 }
 
 
-static int
-mrsas_undo_resources (dev_info_t *dip, struct mrsas_instance *instance)
+static void
+mrsas_undo_resources(dev_info_t *dip, struct mrsas_instance *instance)
 {
 	int	instance_no;
 
@@ -1030,42 +1159,44 @@
 	instance_no = ddi_get_instance(dip);
 
 
-	if(instance->unroll.ioctl == 1)  {
+	if (instance->unroll.ioctl == 1) {
 		ddi_remove_minor_node(dip, instance->iocnode);
 		instance->unroll.ioctl = 0;
 	}
 
-	if(instance->unroll.scsictl == 1)  {
+	if (instance->unroll.scsictl == 1) {
 		ddi_remove_minor_node(dip, "scsi");
 		instance->unroll.scsictl = 0;
 	}
 
-	if(instance->unroll.devctl == 1)  {
+	if (instance->unroll.devctl == 1) {
 		ddi_remove_minor_node(dip, "devctl");
 		instance->unroll.devctl = 0;
 	}
 
-	if(instance->unroll.tranSetup == 1)  {
+	if (instance->unroll.tranSetup == 1) {
 		if (scsi_hba_detach(dip) != DDI_SUCCESS) {
 			cmn_err(CE_WARN,
-				"mr_sas2%d: failed to detach", instance_no);
-			return (DDI_FAILURE);
+			    "mr_sas2%d: failed to detach", instance_no);
+			return;	 /* DDI_FAILURE */
 		}
 		instance->unroll.tranSetup = 0;
-		con_log(CL_ANN1, (CE_CONT, "scsi_hba_dettach()  done."));
+		con_log(CL_ANN1, (CE_CONT, "scsi_hba_dettach()	done."));
 	}
 
-	if(instance->unroll.tran == 1)  {
+	if (instance->unroll.tran == 1)	 {
 		scsi_hba_tran_free(instance->tran);
 		instance->unroll.tran = 0;
 		con_log(CL_ANN1, (CE_CONT, "scsi_hba_tran_free()  done."));
 	}
 
-	if(instance->unroll.syncCmd == 1)  {
-		if(instance->tbolt) {
-			if (abort_syncmap_cmd(instance, instance->map_update_cmd))
+	if (instance->unroll.syncCmd == 1) {
+		if (instance->tbolt) {
+			if (abort_syncmap_cmd(instance,
+			    instance->map_update_cmd)) {
 				cmn_err(CE_WARN, "mrsas_detach: "
-					"failed to abort previous syncmap command");
+				    "failed to abort previous syncmap command");
+			}
 
 			instance->unroll.syncCmd = 0;
 			con_log(CL_ANN1, (CE_CONT, "sync cmd aborted, done."));
